<template>
  <div>
    <span v-if="isSend">Order sent successfully</span>
    <form
      v-if="!isSend"
      class="order-form"
      novalidate="true"
      @submit="sendForm"
    >
      <div v-if="errors.length">
        <b>Please correct the following error(s):</b>
        <ul>
          <li
            v-for="(error, idx) in errors"
            :key="idx"
          >
            {{ error }}
          </li>
        </ul>
      </div>
      <div class="order-form_row">
        <span>Name:</span>
        <input
          v-model.trim="name"
          type="text"
          required
        >
      </div>
      <div class="order-form_row">
        <span>Delivery type:</span>
        <select
          v-model="deltype"
          required
        >
          <option
            disabled
            value=""
          >
            Choose one of the options
          </option>
          <option value="0">
            Delivery
          </option>
          <option value="1">
            Self Pickup
          </option>
        </select>
      </div>
      <div class="order-form_row">
        <span>Delivery date:</span>
        <input
          v-model="date"
          type="date"
          required
        >
      </div>
      <div class="order-form_row">
        <span>Products:</span>
        <input
          id="pizza"
          v-model="products"
          type="radio"
          value="0"
        >
        <label for="pizza">Pizza</label>
        <input
          id="Sushi"
          v-model="products"
          type="radio"
          value="1"
        >
        <label for="Sushi">Sushi</label>
        <input
          id="burgers"
          v-model="products"
          type="radio"
          value="2"
        >
        <label for="burgers">Burgers</label>
      </div>
      <div class="order-form_row center">
        <input
          id="needCall"
          v-model="needCall"
          type="checkbox"
        >
        <label for="needCall">Need to call back.</label>
      </div>

      <input
        type="submit"
        value="Send order"
      >
    </form>
  </div>
</template>

<script>
import { OrdersApi } from '../api/OrdersApi'
import { ordersUrl } from '../config/config'

export default {
  data: function () {
    return {
      isSend: false,
      errors: [],
      name: null,
      products: null,
      needCall: false,
      deltype: null,
      date: null
    }
  },
  methods: {
    sendForm: async function (e) {
      e.preventDefault()
      if (this.checkForm()) {
        const newOrder = {
          name: this.name,
          deliveryType: parseInt(this.deltype),
          date: new Date(this.date).toISOString(),
          products: parseInt(this.products),
          needCall: this.needCall
        }
        const api = new OrdersApi(ordersUrl)
        const response = await api.addOrder(newOrder)
        if (response.IsSuccess) {
          this.isSend = true
        } else {
          alert(response.Errors.join('\n'))
          console.error(response.StatusCode, response.Errors)
        }
      }
    },
    checkForm: function () {
      this.errors = []

      if (!this.name) {
        this.errors.push('Name required')
      }
      if (this.deltype === null) {
        this.errors.push('Delivery type required')
      }
      if (!this.date) {
        this.errors.push('Delivery date required')
      } else if (new Date(this.date) <= new Date()) {
        this.errors.push('Delivery date must be later than today.')
      }
      if (this.products === null) {
        this.errors.push('Products required')
      }
      if (!this.errors.length) {
        return true
      }
      return false
    }
  }
}
</script>
